<?php
class ContractAction extends Action {
	public function _initialize(){
		$action = array(
			'permission'=>array(),
			'allow'=>array()
		);
		B('Authenticate', $action);
	}
	public function add(){
		if($_POST['submit']){
			$contract = M('contract');
			$data['number'] = (trim($_POST['number']) && (trim($_POST['number']) != '自动生成')) ?trim($_POST['number']):'5KCRM'.date('Ymd').rand(1000,9999);
			$data['due_time'] = $_POST['due_time']?strtotime($_POST['due_time']):time();
			$data['business_id'] = $_POST['business_id']?$_POST['business_id']:alert('error','请选择商机',$_SERVER['HTTP_REFERER']);
			$data['owner_role_id'] = $_POST['owner_role_id']?$_POST['owner_role_id']:session('role_id');
			$data['creator_role_id'] = session('role_id');
			$data['price'] = intval($_POST['price']);
			$data['content'] = trim($_POST['content']);
			$data['description'] = trim($_POST['description']);
			$data['create_time'] = time();
			$data['update_time'] = time();
			$data['status'] = '已创建';
			if($contractId = $contract->add($data)){
				M('RBusinessContract')->add(array('contract_id'=>$contractId,'business_id'=>$data['business_id']));
				if('保存' == $_POST['submit']){
					alert('success', '创建合同成功', U('contract/index'));
				}else{
					alert('success', '创建合同成功', $_SERVER['HTTP_REFERER']);
				}
			}else{
				alert('success', '创建合同失败', U('contract/add'));
			}
			
		}else{
			if(intval($_GET['business_id'])){
				$this->assign('business_id',intval($_GET['business_id']));
				$this->display('adddialog');
			}else{
				$this->display();
			}
		}
	}
	
	public function edit(){
		$contract = D('contractView');
		$contract_id = intval($_REQUEST['id']) ? intval($_REQUEST['id']) : alert('error', '参数错误!',$_SERVER['HTTP_REFERER']);
		$contract_info = $contract->where('contract.contract_id = %d',$contract_id)->find();
		if (is_array($contract_info)) {
			if($_POST['submit']){
				$data['due_time'] = $_POST['due_time']?strtotime($_POST['due_time']):time();
				$data['business_id'] = $_POST['business_id']?$_POST['business_id']:alert('error','请选择商机',$_SERVER['HTTP_REFERER']);
				$data['owner_role_id'] = $_POST['owner_role_id']?$_POST['owner_role_id']:session('role_id');
				$data['price'] = intval($_POST['price']);
				$data['content'] = trim($_POST['content']);
				$data['description'] = trim($_POST['description']);
				$data['update_time'] = time();
				$data['status'] = $_POST['status'];
				if(M('contract')->where(array('contract_id'=>$contract_id))->save($data)){
					M('rBusinessContract')->where(array('contract_id'=>$contract_id))->save(array('business_id'=>$data['business_id']));
					alert('success', '修改成功',$_SERVER['HTTP_REFERER']);
				}else{
					alert('success', '数据无变化',$_SERVER['HTTP_REFERER']);
				}
			}else{
				$this->assign('info',$contract_info);
				$this->alert = parseAlert();
				$this->display();
			}
		}else{
			alert('error', '数据不存在!',$_SERVER['HTTP_REFERER']);
		}
	}
	
	public function view(){
		$contract_id = intval($_REQUEST['id']);
		$contract = D('contractView');
		if (0 == $contract_id) alert('error', '您没有选择任何内容！', U('contract/index'));
		
		$info = $contract->where(array('contract_id'=>$contract_id))->find();

		if(empty($info)) alert('error', '合同不存在或已被删除！', U('contract/index'));
		$info['creator_name'] = M('user')->where('role_id = %d', $info['creator_role_id'])->getField('name');
		
		$info['product'] = M('rContractProduct')->where('contract_id = %d', $contract_id)->select();
		$product_count =  M('rContractProduct')->where('contract_id = %d', $contract_id)->count();
		$info['product_count'] = empty($product_count)? 0 : $product_count;
		foreach ($info['product'] as $k => $v) {
			$m_product_category = M('productCategory');
			$product = M('product')->where('product_id = %d', $v['product_id'])->find();
			$info['product'][$k]['info'] = $product;
			$info['product'][$k]['category_name'] = $m_product_category->where('category_id = %d',$product['category_id'])->getField('name'); 
		}
		
		$this->assign('info',$info);
		$this->alert = parseAlert();
		$this->display();

	}
	
	public function delete(){
		$contract_id = is_array($_REQUEST['contract_id']) ? implode(',', $_REQUEST['contract_id']) : $_REQUEST['contract_id'];
		if ('' == $contract_id) {
			alert('error', '您没有选择任何内容！', U('contract/index'));
		} else {
			if(M('contract')->where('contract_id in (%s)', $contract_id)->delete()){
				M('rBusinessContract')->where(array('contract_id'=>$contract_id))->delete();
				M('rContractProduct')->where(array('contract_id'=>$contract_id))->delete();
				alert('success', '删除成功!',U('contract/index'));
			} else {
				alert('error', '删除失败', U('contract/index'));
			}
		}
	}
	
	public function index(){
		$contract = D('contractView');
		$below_ids = getSubRoleId(false);
		$where = array();
		$order = 'contract.create_time desc';
		switch ($_GET['by']){
			case 'create':
				$where['contract.creator_role_id'] = session('role_id');
				break;
			case 'sub' : 
				$where['contract.owner_role_id'] = array('in',implode(',', $below_ids)); 
				break;
			case 'subcreate' : 
				$where['contract.creator_role_id'] = array('in',implode(',', $below_ids)); 
				break;
			case 'today' : 
				$where['contract.due_time'] =  array(array('lt',strtotime(date('Y-m-d', time()))+86400), array('gt',0), 'and'); 
				break;
			case 'week' : 
				$where['contract.due_time'] =  array(array('lt',strtotime(date('Y-m-d', time())) + (date('N', time()) - 1) * 86400), array('gt', 0),'and'); 
				break;
			case 'month' : 
				$where['contract.due_time'] =  array(array('lt',strtotime(date('Y-m-01', strtotime('+1 month')))), array('gt', 0),'and'); 
				break;
			case 'add' : 
				$order = 'contract.create_time desc'; 
				break;
			case 'update' : 
				$order = 'contract.update_time desc'; 
				break;
			default: 
				$where['contract.owner_role_id'] = session('role_id');
				break;
		}
		
		if ($_REQUEST["field"]) {
			if (trim($_REQUEST['field']) == "all") {
				$field = is_numeric(trim($_REQUEST['search'])) ? 'number|owner_role_id|customer_id|create_time|update_time|due_time|price|description' : 'number|description';
			} else {
				$field = trim($_REQUEST['field']);
			}
			$search = empty($_REQUEST['search']) ? '' : trim($_REQUEST['search']);
			$condition = empty($_REQUEST['condition']) ? 'is' : trim($_REQUEST['condition']);

			if	('create_time' == $field || 'update_time' == $field || 'due_date' == $field) {
				$search = is_numeric($search)?$search:strtotime($search);
			}
			switch ($condition) {
				case "is" : $where['contract.'.$field] = array('eq',$search);break;
				case "isnot" :  $where['contract.'.$field] = array('neq',$search);break;
				case "contains" :  $where['contract.'.$field] = array('like','%'.$search.'%');break;
				case "not_contain" :  $where['contract.'.$field] = array('notlike','%'.$search.'%');break;
				case "start_with" :  $where['contract.'.$field] = array('like',$search.'%');break;
				case "end_with" :  $where['contract.'.$field] = array('like','%'.$search);break;
				case "is_empty" :  $where['contract.'.$field] = array('eq','');break;
				case "is_not_empty" :  $where['contract.'.$field] = array('neq','');break;
				case "gt" :  $where['contract.'.$field] = array('gt',$search);break;
				case "egt" :  $where['contract.'.$field] = array('egt',$search);break;
				case "lt" :  $where['contract.'.$field] = array('lt',$search);break;
				case "elt" :  $where['contract.'.$field] = array('elt',$search);break;
				case "eq" : $where['contract.'.$field] = array('eq',$search);break;
				case "neq" : $where['contract.'.$field] = array('neq',$search);break;
				case "between" : $where['contract.'.$field] = array('between',array($search-1,$search+86400));break;
				case "nbetween" : $where['contract.'.$field] = array('not between',array($search,$search+86399));break;
				case "tgt" :  $where['contract.'.$field] = array('gt',$search+86400);break;
				default : $where['contract.'.$field] = array('eq',$search);
			}
			$params = array('field='.trim($_REQUEST['field']), 'condition='.$condition, 'search='.$_REQUEST["search"]);
		}
		
		$p = intval($_GET['page'])?intval($_GET['page']):1;
		$list = $contract->where($where)->page($p.',15')->order($order)->select();
		$count = $contract->where($where)->count();
		import("@.ORG.Page");
		$Page = new Page($count,15);
		if (!empty($_GET['by'])) {
			$params[]=   "by=".trim($_GET['by']);
		}
		$Page->parameter = implode('&', $params);
		$this->assign('page', $Page->show());
		$this->assign('list',$list);
		$this->alert = parseAlert();
		$this->display();
	}
	public function listdialog(){
		$contract = D('contractView');
		$list = $contract->order('create_time desc')->select();
		$this->assign('contractList',$list);
		$this->display();
	}
}