<?php

class ProductAction extends Action {
	
	public function _initialize(){
		$action = array(
			'permission'=>array(),
			'allow'=>array('listdialog','adddialog','editdialog', 'mdelete','allproductdialog')
		);
		B('Authenticate', $action);
	}

	public function index(){
		$product = D('ProductView'); // 实例化User对象
		import('@.ORG.Page');// 导入分页类
		$category = M('product_category');
		$where = array();
		$params = array();
		
		$idArray = Array();
		if($_GET['category_id']){
			$categoryList = getSubCategory($_GET['category_id'], $category_list, '');
			foreach($categoryList as $value){
				$idArray[] = $value['category_id'];
			}
		}
		$idList =empty($idArray)?$_GET['category_id']:$_GET['category_id'] . ',' . implode(',', $idArray);
		$p = isset($_GET['p'])?$_GET['p']:1;
		if ($_REQUEST["field"]) {
			if (trim($_REQUEST['field']) == "all") {
				$field = is_numeric(trim($_REQUEST['search'])) ? 'product.name|cost_price|sales_price|link|product.description|pre_sale_count|stock_count' : 'product.name|link|product.description|development_team';
			} else {
				$field = trim($_REQUEST['field']);
			}
			
			$search = empty($_REQUEST['search']) ? '' : trim($_REQUEST['search']);
			$condition = empty($_REQUEST['condition']) ? 'is' : trim($_REQUEST['condition']);
			if	('development_time' == $field || 'listing_time' == $field) $search = is_numeric($search)?$search:strtotime($search);;
			if (!empty($field)) {
				switch ($condition) {
					case "is" : $where[$field] = array('eq',$search);break;
					case "isnot" :  $where[$field] = array('neq',$search);break;
					case "contains" :  $where[$field] = array('like','%'.$search.'%');break;
					case "not_contain" :  $where[$field] = array('notlike','%'.$search.'%');break;
					case "start_with" :  $where[$field] = array('like',$search.'%');break;
					case "end_with" :  $where[$field] = array('like','%'.$search);break;
					case "is_empty" :  $where[$field] = array('eq','');break;
					case "is_not_empty" :  $where[$field] = array('neq','');break;
					case "gt" :  $where[$field] = array('gt',$search);break;
					case "egt" :  $where[$field] = array('egt',$search);break;
					case "lt" :  $where[$field] = array('lt',$search);break;
					case "elt" :  $where[$field] = array('elt',$search);break;
					case "eq" : $where[$field] = array('eq',$search);break;
					case "neq" : $where[$field] = array('neq',$search);break;
					case "between" : $where[$field] = array('between',array($search-1,$search+86400));break;
					case "nbetween" : $where[$field] = array('not between',array($search,$search+86399));break;
					case "tgt" :  $where[$field] = array('gt',$search+86400);break;
					default : $where[$field] = array('eq',$search);
				}
			}
			$params = array('field='.trim($_REQUEST['field']), 'condition='.$condition, 'search='.$_REQUEST["search"]);
		}
		if ($_GET['category_id']) {
			$where['product.category_id'] = array('in',$idList);
			$count = $product->where($where)->count();
			$list = $product->order('product_id')->where($where)->Page($p.',10')->select();
		} else {
			$count = $product->count();// 查询满足要求的总记录数
			$list = $product->order('product_id')->where($where)->Page($p.',10')->select();
		}

		$Page = new Page($count,10);// 实例化分页类 传入总记录数和每页显示的记录数
		if (!empty($_GET['category_id'])) {
			$params[] = 'by='.trim($_GET['by']);
		}
		$Page->parameter = implode('&', $params);

		$show = $Page->show();// 分页显示输出
		//获取下级和自己的岗位列表,搜索用
		$this->assign('list',$list);// 赋值数据集
		$this->assign('page',$show);// 赋值分页输出
		
		$category_list = $category->select();
		$this->categoryList = getSubCategory(0, $category_list, ''); //类别选项
		
		$this->alert=parseAlert();
		$this->display(); // 输出模板
	}
	
	public function edit(){
		if($_GET['id']){
			$product_category = M('product_category');
			$categoryList = $product_category->select();	//读取分类列表 加载下拉框
			$product = M('product');
			$this->product = $product->where('product_id = ' . $_GET['id'])->find();
			$this->categoryList = $categoryList;
			$this->alert = parseAlert();
			$this->display();
		}elseif($_POST['submit']){
			$product = D('Product');	
			$product -> create();
			if ($product->name == '') {
				alert('error', '请填写产品名！',$_SERVER['HTTP_REFERER']);
			}
			elseif($product->save()){
				if($_POST['submit'] == "保存") {
					alert('success', '产品信息修改成功！', U('product/index'));
				} else {
					alert('success', '产品信息修改成功！', U('product/add'));
				}
			}else{
				alert('error', '没有数据变化，修改失败',$_SERVER['HTTP_REFERER']);		
			}
		}
	}
	
	public function add() {
		if($_POST['submit']) {
			$d_product = D('Product');		
			if ($d_product->create()) {
				$d_product->creator_role_id = session('role_id');
				$d_product->create_date = time();
				if ($d_product->name == '') {
					alert('error', '请填写产品名！',$_SERVER['HTTP_REFERER']);
				}
				elseif ($d_product->add()) {
					if($_POST['submit'] == "保存") {
						alert('success', '添加成功！', U('product/index'));
					} else {
						alert('success', '添加成功！', U('product/add'));
					}
				} else {
					alert('error', '参数错误,添加失败！',$_SERVER['HTTP_REFERER']);
				}
			} else {
				alert('error', $d_product->getError(), $_SERVER['HTTP_REFERER']);
			}
		} else {
			$product_category = M('product_category');			
			$category_list = $product_category->select();			

			$this->assign('category_list', getSubCategory(0, $category_list, ''));
			$this->alert = parseAlert();
			$this->display();
		}
//		elseif($_GET['r'] & $_GET['module'] & $_GET['id']){
//			$product_category = M('product_category');			
//			$category_list = $product_category->select();
//			$this->assign('category_list', getSubCategory(0, $category_list, ''));
//			
//			$this->r = $_GET['r'];
//			$this->module = $_GET['module'];
//			$this->id = $_GET['id'];
//			$this->display('Product:add_dialog');
//		}elseif ($_POST['dialog_add']) {
//				$m_r = M($_POST['r']);
//				$d_product = D('Product');
//				$d_product->create();
//				if($product_id = $d_product->add()){
//					$module_id = $_POST['module'] . '_id';
//					$data['product_id'] = $product_id;
//					$data[$module_id] = $_POST['id'];
//					if ($m_r->add($data)) {
//						alert('success','添加产品成功！',$_SERVER['HTTP_REFERER']);
//					} else {
//						alert('error','添加产品失败！',$_SERVER['HTTP_REFERER']);
//					}
//				}
//		}
		
	}
	
	public function view(){
		$product_id = isset($_GET['id']) ? intval($_GET['id']) : 0;
		if (0 == $product_id) {
			alert('error', '参数错误！', U('product/index'));
		} else {
			$product = M('product')->where('product_id = %d', $product_id)->find();
			
			$product_category = M('product_category');
			$categoryList = $product_category->select();
			
			$product['owner'] = D('RoleView')->where('role.role_id = %d', $product['owner_role_id'])->find();
			
			$log_ids = M('rLogProduct')->where('product_id = %d', $product_id)->getField('log_id', true);
			$product['log'] = M('log')->where('log_id in (%s)', implode(',', $log_ids))->select();
			$log_count = 0;
			foreach ($product['log'] as $key=>$value) {
				$product['log'][$key]['owner'] = D('RoleView')->where('role.role_id = %d', $value['role_id'])->find();
				$log_count++;
			}
			$product['log_count'] = $log_count; 
			
			$file_ids = M('rFileProduct')->where('product_id = %d', $product_id)->getField('file_id', true);
			$product['file'] = M('file')->where('file_id in (%s)', implode(',', $file_ids))->select();
			$file_count = 0;
			foreach ($product['file'] as $key=>$value) {
				$product['file'][$key]['owner'] = D('RoleView')->where('role.role_id = %d', $value['role_id'])->find();
				$file_count++;
			}
			$product['file_count'] = $file_count;
			
			$task_ids = M('rProductTask')->where('product_id = %d', $product_id)->getField('task_id', true);
			$product['task'] = M('task')->where('task_id in (%s)', implode(',', $task_ids))->select();
			$task_count = 0;
			foreach ($product['task'] as $key=>$value) {
				$product['task'][$key]['owner'] = D('RoleView')->where('role.role_id = %d', $value['owner_role_id'])->find();
				$task_count ++;
			}
			$product['task_count'] = $task_count;
			
			$event_ids = M('rEventProduct')->where('product_id = %d', $product_id)->getField('event_id', true);
			$product['event'] = M('event')->where('event_id in (%s)', implode(',', $event_ids))->select();
			$event_count = 0;
			foreach ($product['event'] as $key=>$value) {
				$product['event'][$key]['owner'] = D('RoleView')->where('role.role_id = %d', $value['owner_role_id'])->find();
				$event_count ++;
			}
			$product['event_count'] = $event_count;
			
			$this->product = $product;
			$this->categoryList = $categoryList;	
			$this->alert = parseAlert();
			$this->display();
		}	
	}
	
	public function delete(){
		$m_product = M('product');
		$r_module = array('Log'=>'RLogProduct', 'File'=>'RFileProduct','rBusinessProduct','rContractProduct');
		if($this->isPost()){
			$product_ids = is_array($_POST['product_id']) ? implode(',', $_POST['product_id']) : '';
			if ('' == $product_ids) {
				alert('error', '您没有选择任何内容！', U('product/index'));
			} else {
				if (!session('?admin')) {
					foreach($_POST['product_id'] as $key => $value){
						if(!$m_product->where('creator_role_id = %d and product_id = %d', session('role_id'), $value)->find()){
						echo $m_product->getLastSql(); die();
							alert('error', '您没有全部权限进行操作！', $_SERVER['HTTP_REFERER']);
						}
					}
				}
				
				if($m_product->where('product_id in (%s)', $product_ids)->delete()){
					foreach ($_POST['product_id'] as $value) {
						foreach ($r_module as $key2=>$value2) {
							$module_ids = M($value2)->where('product_id = %d', $value)->getField($key2 . '_id', true);
							M($value2)->where('product_id = %d', $value) -> delete();
							if(!is_int($key2)){	
								M($key2)->where($key2 . '_id in (%s)', implode(',', $module_ids))->delete();
							}
						}
					}
					alert('success', '删除成功!',U('product/index'));
				} else {
					alert('error', '删除失败，联系管理员！', U('product/index'));
				}
				
			}
		} elseif($_GET['id']) {
			$product_id = intval($_GET['id']);
			$product = $m_product->where('product_id = %d', $product_id)->find();
			if (is_array($product)) {
				if(session('?admin') || $product['creator_role_id'] == session('role_id')){
					if($m_product->where('product_id = %d', $product_id)->delete()){
						foreach ($r_module as $key2=>$value2) {
							if(!is_int($key2)){
								$module_ids = M($value2)->where('product_id = %d', $product_id)->getField($key2 . '_id', true);
								M($value2)->where('product_id = %d', $product_id) -> delete();
								M($key2)->where($key2 . '_id in (%s)', implode(',', $module_ids))->delete();
							}
						}
						alert('success', '删除成功!', U('product/index'));
					}else{
						alert('error', '删除失败，请联系管理员！', U('product/index'));
					}
				} else {
					alert('error', '您没有权限！', $_SERVER['HTTP_REFERER']);
				}
					
			} else {
				alert('error', '记录不存在！', U('leads/index'));
			}			
		} else {
			alert('error', '请选择要删除的线索!',$_SERVER['HTTP_REFERER']);
		}
	}
	
	public function mDelete(){
		if($_GET['id']){
			$m_r = M($_GET['r']);
			if($m_r->where("id = %d", trim($_GET['id']))->delete()){
				alert('success','删除成功',$_SERVER['HTTP_REFERER']);
			} else {
				alert('error','删除失败',$_SERVER['HTTP_REFERER']);
			}
		} else {
			alert('error','参数错误！',$_SERVER['HTTP_REFERER']);
		}
	}
	
	public function editDialog(){
		if($this->isPost()){
			$r = trim($_POST['r']);
			$d_r = D($r);
			$d_r->create();
			if($d_r->save()){
				alert('success', '修改成功',$_SERVER['HTTP_REFERER']);
			}else{
				alert('error', '修改失败！',$_SERVER['HTTP_REFERER']);
			}
		}elseif ($_GET['r'] && $_GET['id']) {
			$rbs = M($_GET['r'])->where('id = %d', $_GET['id'])->find();
			$rbs['info'] = M('product')->where('product_id = %d', $rbs['product_id'])->find();
			$this->r = $_GET['r'];
			$this->rbs = $rbs;
			$this->display();
		}else{
			alert('error', '参数错误！',$_SERVER['HTTP_REFERER']);
		}
	}
	
	public function listDialog(){
		if($this->isPost()){
			$r = $_POST['r'];
			$model_id = isset($_POST['id']) ? intval($_POST['id']) : 0;
			$product_id = isset($_POST['product_id']) ? intval($_POST['product_id']) : 0;
			$m_r = M($r);
			$m_id = $_POST['module'] . '_id';  //对应模块的id字段
			
			$data[$m_id] = $model_id;
			foreach ($_POST['product_id'] as $value) {
				$data['product_id'] = $value;
				if ($m_r -> add($data) <= 0) {
					alert('error', '选择产品失败！',$_SERVER['HTTP_REFERER']);
				}
			}
			alert('success', '选择产品成功！',$_SERVER['HTTP_REFERER']);
		}elseif ($_GET['r'] && $_GET['module'] && $_GET['id']) {
			$id_array = M($_GET['r']) -> where($_GET['module'] . '_id = %d', $_GET['id']) -> getField('product_id', true);
			$id_array[] = 0;
			$this -> r = $_GET['r'];
			$this -> module = $_GET['module'];
			$this -> model_id = $_GET['id'];
			$d_product = D('ProductView');
			$a = $d_product->where('product_id not in (%s)', implode(',',$id_array))->select();
			$this->list = $a;
			$this->display();
		}else{
			alert('error', '参数错误！',$_SERVER['HTTP_REFERER']);
		}
	}
	
	public function addDialog(){
		if($this->isPost()){
			$r = $_POST['r'];
			$model_id = isset($_POST['model_id']) ? intval($_POST['model_id']) : 0;
			$product_id = isset($_POST['product_id']) ? intval($_POST['product_id']) : 0;
			$m_r = D($r);
			$m_id = $_POST['module'] . '_id';  //对应模块的id字段
			$m_r->create();
			$m_r->$m_id = $model_id;
			if ($m_r -> add()) {
				alert('success', '添加成功！',$_SERVER['HTTP_REFERER']);
			} else {
				alert('error', '添加失败！',$_SERVER['HTTP_REFERER']);
			}
			
		}elseif ($_GET['r'] && $_GET['module'] && $_GET['id']) {
			$id_array = M($_GET['r']) -> where($_GET['module'] . '_id = %d', $_GET['id']) -> getField('product_id', true);
			$id_array[] = 0;
			$this -> r = $_GET['r'];
			$this -> module = $_GET['module'];
			$this -> model_id = $_GET['id'];
			$d_product = D('ProductView');
			$a = $d_product->where('product_id not in (%s)', implode(',',$id_array))->select();
			$this->list = $a;
			$this->display();
		}else{
			alert('error', '参数错误！',$_SERVER['HTTP_REFERER']);
		}
	}
	
	public function allProductDialog(){
		$d_product = D('ProductView');
		$this->list = $d_product->select();
		$this->display();
	}
	
	public function category(){
		$product_category = M('product_category');			
		$category_list = $product_category->select();	
		$category_list = getSubCategory(0, $category_list, '');
		
		foreach($category_list as $key=>$value){
			$product = M('product');
			$count = $product->where('category_id = %d', $value['category_id'])->count();
			$category_list[$key]['count'] = $count;
			$category_list[$key]['list'] = $product->where('category_id = %d', $value['category_id'])->select();
		}
		$this->alert=parseAlert();
		$this->assign('category_list', $category_list);
		$this->display();
	}
	
	public function category_add(){
		if (isset($_POST['name']) && $_POST['name'] != '') {
			$category = D('ProductCategory');
			if ($t = $category->create()) {
				if ($category->add()) {					
					alert('success', '添加成功！',$_SERVER['HTTP_REFERER']);			
				} else {
					alert('error', '参数错误,添加失败！',$_SERVER['HTTP_REFERER']);			
				}				
			} else {	
				exit($category->getError());				
			}
		}else{
			$category = M('product_category');			
			$category_list = $category->select();			
			$this->assign('category_list', getSubCategory(0, $category_list, ''));
			$this->display();
		}
	}
	
	public function category_delete(){
		$product_category = M('Product_category');
		$product = M('product');
		if($_POST['category_list']){
			foreach($_POST['category_list'] as $value){
				if($product->where('category_id = %d',$value)->select()){
					$name = $product_category->where('category_id = %d',$value)->getField('name');
					alert('error', '删除失败，请先删除"'.$name.'"类别下的产品',$_SERVER['HTTP_REFERER']);
				}
				if($product_category->where('parent_id = %d',$value)->select()){
					$name = $product_category->where('category_id = %d',$value)->getField('name');
					alert('error', '删除失败，请先删除"'.$name.'"类别下的子类别',$_SERVER['HTTP_REFERER']);
				}
			}
			if($product_category->where('category_id in (%s)', join($_POST['category_list'],','))->delete()){
				alert('success', '删除类别成功！',$_SERVER['HTTP_REFERER']);
			}else{
				alert('error', '删除类别失败！',$_SERVER['HTTP_REFERER']);
			}
		}elseif($_GET['id']){
			if($product->where('category_id = %d',$_GET['id'])->select()){
				$this->error('删除失败，清先删除该类别下的产品');
				alert('error', '参数错误,添加失败！',$_SERVER['HTTP_REFERER']);	
			}
			if($product->where('parent_id = %d',$_GET['id'])){
				alert('error', '请先删除该类别的子类别',$_SERVER['HTTP_REFERER']);	
			}else{
				$this->error('参数错误！');
			}
		}else{
			$this->error('删除失败！');
		}	
	}
	
	//编辑产品分类信息
	public function category_edit(){
		if($_GET['id']){
			$product_category = M('product_category');			
			$category_list = $product_category->select();	
			$this->assign('category_list', getSubCategory(0, $category_list, ''));
			$product_category = M('product_category');
			$categoryList = $product_category->select();	//读取分类列表 加载下拉框
			foreach($categoryList as $key=>$value){
				if($value['category_id'] == $_GET['id']){
					unset($categoryList[$key]);
				}
			}
			
			$this->category_list = $categoryList;
			$this->temp =$product_category->where('category_id = ' . $_GET['id'])->find();
			
			$this->display();
		}elseif($_POST['category_id']){
			$product_category = M('product_category');	
			$product_category -> create();
			if($product_category->save()){
				alert('success','修改类别信息成功！',$_SERVER['HTTP_REFERER']);
			}else{
				alert('error','没有数据变化，修改类别信息失败',$_SERVER['HTTP_REFERER']);
			}
		}else{
			$this->error('参数错误!');
		}
	}
	
	//产品销量统计
	public function count(){
		//商机	产品	销量	成本	交易价	盈利
		$sales = D('SalesView');
		$sales_list = $sales->order('create_time')->select();
		foreach($sales_list as $key=>$value){
			$count = $value['product_amount'];
			$sales_price = $value['sales_price'];
			$cost_price = $value['cost_price'];
			$profit = $count*($sales_price-$cost_price);
			$sales_list[$key]['profit'] = $profit;
		}
		
		$this->salesList = $sales_list;
		$this->display();
	}
	
	public function excelExport(){
		import("ORG.PHPExcel.PHPExcel");
		$objPHPExcel = new PHPExcel();    
		$objProps = $objPHPExcel->getProperties();    
		$objProps->setCreator("5kcrm");    
		$objProps->setLastModifiedBy("5kcrm");    
		$objProps->setTitle("5kcrm Product");    
		$objProps->setSubject("5kcrm Product Data");    
		$objProps->setDescription("5kcrm Product Data");    
		$objProps->setKeywords("5kcrm Product");    
		$objProps->setCategory("5kcrm");
		$objPHPExcel->setActiveSheetIndex(0);     
		$objActSheet = $objPHPExcel->getActiveSheet(); 
		   
		$objActSheet->setTitle('Sheet1');
		$objActSheet->setCellValue('A1', '产品名');
		$objActSheet->setCellValue('B1', '产品类别');
		$objActSheet->setCellValue('C1', '成本');
		$objActSheet->setCellValue('D1', '建议报价');
		$objActSheet->setCellValue('E1', '开发团队');
		$objActSheet->setCellValue('F1', '开发时间');
		$objActSheet->setCellValue('G1', '上市时间');
		$objActSheet->setCellValue('H1', '预售');
		$objActSheet->setCellValue('I1', '库存');
		$objActSheet->setCellValue('J1', '详情链接');
		$objActSheet->setCellValue('K1', '描述');
		$objActSheet->setCellValue('L1', '创建人');
		$objActSheet->setCellValue('M1', '创建时间');

		$list = D('ProductView')->select();
		$i = 1;
		foreach ($list as $k => $v) {
			$i++;
			$creator = D('RoleView')->where('role.role_id = %d', $v['creator_role_id'])->find();
			$objActSheet->setCellValue('A'.$i, $v['name']);
			$objActSheet->setCellValue('B'.$i, $v['category_name']);
			$objActSheet->setCellValue('C'.$i, $v['cost_price']);
			$sug_price = $v['suggested_price'] > 0 ? $v['suggested_price'] : '';
			$objActSheet->setCellValue('D'.$i, $sug_price);
			$objActSheet->setCellValue('E'.$i, $v['development_team']);
			$v['development_time'] > 0 ? $objActSheet->setCellValue('F'.$i, date("Y-m-d", $v['development_time'])) : '';
			$v['listing_time'] > 0 ? $objActSheet->setCellValue('G'.$i, date("Y-m-d", $v['listing_time'])) : '';
			$pre_count = $v['pre_sale_count'] > 0 ? $v['pre_sale_count'] : '';
			$objActSheet->setCellValue('H'.$i, $pre_count);
			$stock_count = $v['stock_count'] > 0 ? $v['stock_count'] : '';
			$objActSheet->setCellValue('I'.$i, $stock_count);
			$objActSheet->setCellValue('J'.$i, $v['link']);
			$objActSheet->setCellValue('K'.$i, $v['description']);
			$objActSheet->setCellValue('L'.$i, $creator['user_name'].'['.$creator['department_name'] .'-'. $creator['role_name'] .']' );
			$objActSheet->setCellValue('M'.$i, date("Y-m-d H:i:s", $v['create_date']));
		}
		$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
		header("Content-Type: application/vnd.ms-excel;");
        header("Content-Disposition:attachment;filename=5kcrm_product_".date('Y-m-d',mktime()).".xls");
        header("Pragma:no-cache");
        header("Expires:0");
        $objWriter->save('php://output'); 
	}

	public function excelImport(){
		$m_product = M('product');
		if($_POST['submit']){
			if (isset($_FILES['excel']['size']) && $_FILES['excel']['size'] != null) {
				import('@.ORG.UploadFile');
				$upload = new UploadFile();
				$upload->maxSize = 20000000;
				$upload->allowExts  = array('xls');
				$dirname = './Uploads/' . date('Ym', time()).'/'.date('d', time()).'/';
				if (!is_dir($dirname) && !mkdir($dirname, 0777, true)) {
					alert('error', '附件上传目录不可写', U('product/index'));
				}
				$upload->savePath = $dirname;
				if(!$upload->upload()) {
					alert('error', $upload->getErrorMsg(), U('product/index'));
				}else{
					$info =  $upload->getUploadFileInfo();
				}
			}
			if(is_array($info[0]) && !empty($info[0])){
				$savePath = $dirname . $info[0]['savename'];
			}else{
				alert('error', '上传失败', U('product/index'));
			};
			import("ORG.PHPExcel.PHPExcel");
			$PHPExcel = new PHPExcel();
			$PHPReader = new PHPExcel_Reader_Excel2007();
			if(!$PHPReader->canRead($savePath)){
				$PHPReader = new PHPExcel_Reader_Excel5();
			}
			$PHPExcel = $PHPReader->load($savePath);
			$currentSheet = $PHPExcel->getSheet(0);
			$allRow = $currentSheet->getHighestRow();
			for($currentRow = 2;$currentRow <= $allRow;$currentRow++){
				$data = array();
				$data['create_date'] = time();
				$data['creator_role_id'] = session('role_id');
				$name = $currentSheet->getCell('A'.$currentRow)->getValue();
				if ($m_product->where('name = "%s"', $name)->find()) {
					alert('error', '导入至第' . $currentRow . '行出错, 原因："'.$name.'"产品名已存在', U('product/index'));
					break;
				} elseif($name == '' || $name == null) {
					alert('error', '导入至第' . $currentRow . '行出错, 原因：产品名不能为空！', U('product/index'));
				} else {
					$data['name'] = $name;
				}				
				$category = $currentSheet->getCell('B'.$currentRow)->getValue();
				$category_id = M('ProductCategory')->where('name = "%s"', $category)->getField('category_id');
				if($category_id > 0){
					$data['category_id'] = $category_id;
				}else{
					$data['category_id'] = 0;
				}
				$cost_price =  $currentSheet->getCell('C'.$currentRow)->getValue();
				if($cost_price != '' && $cost_price != null) $data['cost_price'] = $cost_price;
				$suggested_price =  $currentSheet->getCell('D'.$currentRow)->getValue();
				if($suggested_price != '' && $suggested_price != null) $data['suggested_price'] = $suggested_price;
				$development_team =  $currentSheet->getCell('E'.$currentRow)->getValue();
				if($development_team != '' && $development_team != null) $data['development_team'] = $development_team;
				
				$development_time = $currentSheet->getCell('F'.$currentRow)->getValue();
				if($development_time > 0) $data['development_time'] = intval(PHPExcel_Shared_Date::ExcelToPHP($development_time))-8*60*60;
				$listing_time = $currentSheet->getCell('G'.$currentRow)->getValue();
				if($listing_time > 0) $data['listing_time'] = intval(PHPExcel_Shared_Date::ExcelToPHP($listing_time))-8*60*60;
				$pre_sale_count =  $currentSheet->getCell('H'.$currentRow)->getValue();
				if($pre_sale_count != '' && $pre_sale_count != null) $data['pre_sale_count'] = $pre_sale_count;
				$stock_count = $currentSheet->getCell('I'.$currentRow)->getValue();
				if($stock_count != '' && $stock_count != null) $data['stock_count'] = $stock_count;
				$link = $currentSheet->getCell('J'.$currentRow)->getValue();
				if($link != '' && $link != null) $data['link'] = $link;
				$description = $currentSheet->getCell('K'.$currentRow)->getValue();
				if($description != '' && $description != null) $data['description'] = $description;
				if (!$m_product->add($data)) {
					alert('error', $m_product->getLastSql() . '导入至第' . $currentRow . '行添加数据出错', U('business/index'));
				}
			} 
			alert('success', '导入成功', U('product/index'));
		}else{
			$this->display();
		}
	}
}